/* 5 May 1999. An SRE-http addon. 

    GETAFILE  :   Displays files in a selected subdirectory (of the data
                  directory, and allows you to retrieve a file.

        See GF_DOC.HTM for details

   Example:

/getafile?/public&header=Public+Files&dispfile=READ.ME&displine=40&GIFS&dirs

    Would find all files in /public (relative to the
    data directory), write a H2 header of "Public Files"
    display the READ.ME file, and note the files with a gif.
                 
     Note that for security, only files and directories under the
     data directory (or a virtual directory) are accessible 


************************/
getafile:


/******* USER CONFIGURABLE PARAMETERS ---------- */

/* note that /TEMP means "do not display TEMP subdirectory (of whatever
 directory you are displaying */

/*exclusion_list=' HTACCESS. GROUP.LST PASSWD.LST /PRIVATE /TEMP '*/
exclusion_list=1   /* use dir_exclusion parameter */


/* spaced delimited list of extensions to "check if they are .ZIP files"
   (do NOT include leading . )
   If used, this should always include ZIP.
   You might also want to include EXE (for self extracting files).  
   Or, to only use  ZIP files (without checking file contents), 
   set zip_file_exts=0.
   Note that if filerexx.dll is not available, zip_file_exts is set to 0.
*/

zip_file_exts='ZIP EXE'


/* bgcolor, etc to use in <TR > elements of tables. Used when TR_COLORS=1 option is specified */

/*TR_COLORS.0 -- number of entries --- getafile will cycle through these entries. 
  TR_COLORS=0 means "no bgcolor, etc. in <TR >" 
 TR_COLORS.n -- a string with bgcolor, background, align, etc. */
tr_colors.0=2
tr_colors.1=' bgcolor="#999900" '
tr_colors.2=' bgcolor="#aacc22" '


/******* End of  USER CONFIGURABLE PARAMETERS ---------- */


parse arg ddir,tempfile,sel,list,averb,auri,auser,abd,awd,apri,enmadd,transaction,verbose,servername,host_nickname,homedir,param


if averb="" then do
   say " This SRE-http procedure is not meant to be run in stand-alone mode "
   exit
end  /* Do */

list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

tindex.0=0
imagepath=translate("/imgs/")
imagesize="width=24 height=24"
list=packur(list)               /* fix up */

dir_access=' '
if exclusion_list=1 then do
    exclusion_list=get_value('DIR_EXCLUSION')
    dir_access=get_value('DIR_ACCESS')
end  /* Do */

exclusion_list=UPPER(translate(exclusion_list,'/','\'))


dirgif='<img src="'ImagePath'menu.gif"' imagesize 'alt="[dir]">'
backgif='<img src="'ImagePath'back.gif"' imagesize 'alt="[..]">'
ballgif='<img src="'ImagePath'blueball.gif"' imagesize 'alt="[**]">'
expndgif='<img src="'ImagePath'expand.gif"' imagesize 'alt="[vu]">'


poop=translate(list,' ','&=')
if words(poop)=1 then do   /* is a "default listings" request */
   list='dir='||poop||'&subdir=TOP&rootdir=!&showgifs=1&showdate=1&showtime=1&showsize=1&dodirs=1&usepre=1&iscreate=1'
end             /* and the rest follows naturally.... */



/* retain old message (a record of directory traverses */

oldmess=list
oldmess=translate(oldmess,'+',' ')
if left(oldmess,4)="DIR=" then do
    foo1=pos('&',oldmess)
    oldmess=delstr(oldmess,1,foo1)
end
else do
  foo1=pos("&DIR=",oldmess)
  if foo1>0 then do
    foo2=pos('&',oldmess,foo1+1)
    if foo2>0 then
       oldmess=delstr(oldmess,foo1+1,foo2-foo1)
  end
end
oldmess='&'||oldmess

messages=list

/* Get options */
showgifs=0 ; maxlines=1000000 ;  readmefile=0
attop=0 ; dirtable=0  ; filetable=0 ;defcols=4
dodirs=0 ;  header=0; filekey=0  ; dorecord=0
showdate=0; showsize=0
forcetext=0 ; tablefile=0 ; usedl=0 ; rootdir=0 ;  html_descripts=0
readmefile_mess=0  ; dirtop=0
tablefile_mess=0 ; iscreate=0
tableborder=0 ; usepre=0 ; showtime=0 ; sizefmt=0 ; cellspacing=2
adir="/"
auto_describe=0
zipfile=0               /* invoking a zip expansion */
do_zipexpand=0          /* make zip expansion lins */
file_fromzip=0       /* extract file from .zip file */
inclusion_list=' '
thumbindex='' ;theind=''  ; thumbsel='' ; theind2=''
tr_colors=0
viewin=' '

/* if just one item in messages; it is assumed to be a directory to be displayed as:
  ICON  filename.ext   14 Feb 1996  12,122
format (using <PRE> to format.
*/

do until messages=" "

  parse var messages amess '&' messages
  parse var amess messname '=' messval
  messval0=strip(packur(translate(messval,' ','+'||'0d0a09'x)))
 

  messname=translate(messname) ; messval=translate(messval0)
  select

    when  "DIR"=messname then
        adir=messval

    when 'VIEWIN'=messname | 'VIEWWIN'=messname | 'VIEW_WIN'=messname then do
         messval=strip(translate(messval,' ','\/'))
         if messval=1 | abbrev(translate(messval),'Y')=1 then 
            viewin=' TARGET="'||messval||'" '
         else
           viewin=''
    end 
    when message="IMGDIR" then do
      messval="/"||strip(messval,,'\')||"/"
      imagepath=translate(messval,'/'.'\')
    end

   when messname="SIZEFMT" then
        sizefmt=upper(messval)

    when messname="HEADER" then
        header=messval

    when abbrev(messname,'PATT')=1 then
        if messval<>0 then inclusion_list=inclusion_list||' '||messval

    when messname="GIFS" | messname='SHOWGIFS' | messname='SHOWGIF' then
        if messval="YES" | messval=1 | messval="Y" then  showgifs=1

    when messname="TABLEBORDER" then
        if messval="YES" then tableborder=1

    when messname="CELLSPACING" then
        if datatype(messval)="NUM"  then cellspacing=messval
     
    when messname="DISPFILE" then do
        tmp=messval
        if  tmp="" | tmp=0 then
           readmefile=0
        else
           parse var  tmp readmefile readmefile_mess
        if readmefile_mess="" then readmefile_Mess=0

      end

    when messname="TABLEFILE" then do
        if abbrev(messval,'HTML:')=1  then do
                 html_descripts=1
                 messval0=substr(messval0,6)
        end  /* Do */
        tmp=messval0
        if tmp=" " | tmp="" then
             tablefile=0
        else
           parse var tmp tablefile tablefile_mess
         if tablefile_mess="" then tablefile_Mess=0
      end

    when messname="USEPRE"  then do
        IF messval="YES" | messval='Y' | messval='1' then usepre=1
    end  /* Do */
 
   when abbrev(messname,"TR_C")=1 & tr_colors.0>0  then do
        IF messval="YES" | messval='Y' | messval='1' then tr_colors=1
    end  /* Do */
 

    when messname="TABLE" then
      select
        when pos("KEY",messval)>0 then do 
           filetable=1 
           filekey=1 
        end
        when pos("FILE",messval)>0 then do
           filetable=1 
            filekey=0 
         end
         when pos("STANDARD",messval)>0 then do
            filetable=1
            filekey=2
         end  /* Do */
         when pos("DIR",messval)>0 then
                dirtable=1
         otherwise
       end

    WHEN MESSNAME="RECORD" THEN
        IF messval="YES" then dorecord=1


    when abbrev(messname,'THUMB')=1 then
        thumbindex=messval

    when messname="AUTO_DESCRIBE" then do
        select 
         when messval="NO"  then auto_describe=0
         when messval="YES" then auto_describe=250
         when datatype(messval)<>'NUM' then auto_describe=0
         otherwise auto_describe=messval
       end
    end

   WHEN MESSNAME="SHOWDATE" THEN do

        IF messval="YES" | messval="Y" | messval=1 then showdate=1
        if messval="YES_SHORT" then showdate=2
   end

   WHEN MESSNAME="SHOWTIME" THEN 
        IF messval="YES" | messval="Y" | messval=1 then showtime=1

   WHEN MESSNAME="SHOWSIZE" THEN
        IF messval="YES" | messval="Y" | messval=1 then showsize=1

    when messname="COLS" | messname="TABLECOLS" then
        if datatype(messval)="NUM" then tablecols=messval


   when messname="ISCREATE" then do
        header=messval0
        iscreate=1
    end

    when messname="USEDL" then
        IF messval="YES" | messval="Y" | messval=1  then usedl=1

    when messname='EXPAND_ZIP' then
        if messval="YES"  | messval="Y" | messval=1 then do_zipexpand=1 


   when messname="DOEXPANDZIP" then do
         foo=pos('BACKTO=',upper(list))
         backto=' '
         if foo<>0 then backto=substr(list,foo+8)
         zipfile=messval
   end  /* Do */

    when messname="FILE_FROMZIP" then do
       file_fromzip=messval  /* regular processing will find the dir= optino */
    end  /* Do */
    when messname="ZIPFILE" then do
       zipfile=messval  /* regular processing will find the dir= optino */
    end  /* Do */


    when messname="ROOTDIR" then
        rootdir=messval

    when pos("LINE",messname)>0 then
        if datatype(messval)="NUM" then maxlines=messval

    when pos("TOP",messname) > 0 then
        if messval="YES" then        attop=1

    when pos("SHOWDIR",messname)>0 | pos("SUBDIR",messname)>0 then do
        dodirs=1
        if messval="TOP"  then  dirtop=1
        if messval="NO" then dodirs=0
        
   end

    when messname="FORCETEXT" then do
         if messval=1 | abbrev(messval,'Y')=1 then forcetext=1
         if messval=0 | abbrev(messval,'N')=1 then forcetext=0
         if messval="CHECK" then forcetext=2
         if messval='CHECK_FIRST' then forcetext=3
    end
    otherwise
         nop
   end           /* select messname */
 
 end            /* loop */

 adir=translate(strip(adir),'/','\')
 adir=strip(adir,'t','/')

 foodir=adir
 if foodir=' ' then foodir='/'
 foodir2='/'strip(foodir,'l','/')
 if abbrev(translate(rootdir),"!")=1 then rootdir=foodir

/* check dir_access */
thesel1a=strip(foodir2,,'/')
do mm=1 to words(dir_access)
  aword=strip(upper(word(dir_access,mm)))
  foo=sref_wildcard(upper(thesel1a),aword)
  parse var foo istat ',' .
  if strip(istat)>0 then do     /* compare dir_access_privs against privset */
      dir_access_privs=get_value('dir_access_privs')||' SUPERUSER'
      do nn=1 to words(dir_access_privs)
          aw2=strip(upper(word(dir_access_privs,nn)))
          if wordpos(aw2,apri) then leave mm  /* he's cool */
      end
      message=" GETAFILE, DIR_ACCESS denial: " thesel1
      if verbose>2 then say message
      'header add WWW-Authenticate: Basic Realm=<GETAFILE>'  /* challenge */
      foo=sref_response('unauth',message,tempfile,servername)
      return foo
   end
end

if usepre=1 then do 
  tablefile=0  /* pre and descriptions can not coeexist */
  filekey=0
end  /* Do */

if auto_describe>0 | zipfile<>0 then do     /*load unzip dll */
   foo=rxfuncquery('UZLoadFuncs')
   if foo=1 then do
     call RxFuncAdd 'UZLoadFuncs', 'UNZIPAPI', 'UZLoadFuncs'
     call UZLoadFuncs
   end
  foo=rxfuncquery('UZLoadFuncs')
  candozip=1
  if foo=1 then candozip=0
end  /* Do */


 if datatype(tablecols)<>"NUM" then            /* default # table columns */
    tablecols=defcols-showgifs

 if header="" | header=0 then  header=' List of files in ' ||foodir

 if tablecols=0 & dirtable=1 then tablecols=1

  tmp=adir||'/*.*'
  lookin=sref_do_virtual(ddir,tmp,enmadd,0,transaction,homedir,host_nickname)
  dp=strip(filespec('d',lookin)||filespec('p',lookin),'t','\')
  wade=directory()
  notwade=directory(dp)
  wade0=directory(wade)

/* fix up thumbindex */
  if thumbindex=0 then thumbindex=''
  if thumbindex<>'' then do
    do it=1 to words(thumbindex)
       tin1=strip(word(thumbindex,it))
       if pos('.',tin1)=0 then tin1=tin1'.ind'
       t1a=sref_do_virtual(ddir,tin1,enmadd,0,transaction,homedir,host_nickname)
       goo=sysfiletree(t1a,'gooz','O')
       if gooz.0=0 then do 
          if verbose>1 then say "GETAFILE Warning: no such thumbnail index: "tin1
       end /* do */
       else do    /* determine anti virtual stuff */
         do ig=1 to gooz.0
           tin2=gooz.ig
           theind=theind' 'tin2
           t2=length(strip(filespec('d',tin2)||filespec('p',tin2),,'\')'\')
           theind2=theind2' 't2
           tt2=strip(translate(tin1,' ','/\'))
           iww=words(tt2)
           if iww=1 then do
               thumbsel=thumbsel' /'
           end
           else do
              tt2=strip(delword(tt2,iww))
              thumbsel=thumbsel' 'translate(tt2,'/',' ')'/'
           end
        end             /* sysfiletree loop */
       end        /* good index, determining other stuff */
    end          /* each word in thumbindex */
  
  end           /* not a blank thumbindex */
/* obsolete, but retain for now */
/* missing, and let caller take care of it? */
   if lookin = " " | lookin=0 | notwade="" then do               /* ERROR */
      if param=1 then return -1   /* if param= -1, then let calling routine say bye */
   end
/***/

/*SPECIAL CASE:  check for "zip file expansion */
if zipfile<>0  & file_fromzip=0 then do
   if candozip=0  then do
        call error_4
        oof=dosdir(tempfile,'s')
       return 'FILE ERASE TYPE text/html NAME' tempfile
   end  /* Do */
   foo=show_zipdir(zipfile,adir,backto,lookin)  /* show_zip will creat the tempfile */
    oof=dosdir(tempfile,'s')
   return 'FILE ERASE TYPE text/html NAME' tempfile
end  /* Do */

/* Special case: extract a file from a zip file */
if file_fromzip<>0 then do
   if candozip=0  then do
        call error_4
        oof=dosdir(tempfile,'s')
       return 'FILE ERASE TYPE text/html NAME' tempfile
   end  /* Do */

/* check access priviliges? */
  if wordpos('*',apri)<>'SUPERUSER'  then do
      astat=check_access(adir,lookin,zipfile,host_nickname,enmadd,transaction,apri)
      if astat=0 then do
          'header add WWW-Authenticate: Basic Realm=</'||strip(ADIR,,'/')||'>'  /* challenge */
         return sref_response('unauth', "You do not have privileges for the file: "zipfile,tempfile,servername)
      end
  end  /* access privs */

  foo=send_zipfile(file_fromzip,zipfile,lookin)
  return foo
end

/* Commence regular directory display --- */

/* Everyhint below here needs this */
  call lineout tempfile,' <!DOCTYPE HTML PUBLIC  "-//Netscape Comm. Corp.//DTD HTML//EN">'
  call lineout tempfile, "<html><head><title>Listing of "servername foodir2" </title></head>"
  call lineout tempfile, "<body>"


  if lookin = " " | lookin=0 | notwade="" then do               /* ERROR */
      call error_0
      oof=dosdir(tempfile,'s')
      return 'FILE ERASE TYPE text/html NAME' tempfile
  end

/* if here, directory exists so get its files and subds */
   rc = SysFileTree(lookin,'flist', 'FT')
   if rc <> 0 then do    /* error */
     call error_1
      oof=dosdir(tempfile,'s')
     return 'FILE ERASE TYPE text/html NAME' tempfile
   end

   thepath=delstr(lookin,pos('\*.*',lookin))
   if VERBOSE>1 then say " Getting files from " thepath

/* Else,  create list of links to files */
   nzipfs=0
   do i=1 to flist.0
       parse var flist.i adatetime asize ee3 fname
       parse var adatetime yyy '/' mmm '/' ddd '/' hhh '/' minu
       if yyy<70  then
          yyy='20'||yyy
       else
          yyy='19'||yyy
       ndate=yyy||mmm||ddd
       atime=hhh':'minu

       afil=filespec("name",fname)

       dracula=pos('.',afil) ; 
       godzilla=upper(afil)
       if dracula=0 then godzilla=afil'.'
       if wild_wordpos(godzilla,exclusion_list)>0 then do  /* excluded? */
             flist.i.name=' '
             iterate
       end  /* Do */
       if  inclusion_list<>' ' then do
           if wild_wordpos(godzilla,inclusion_list)=0 then do /* not included? */
              flist.i.name=' '
              iterate
           end  /* Do */
       end  /* Do */

       if dracula=0 then afil=afil||'.'

       asize=fixup_size(sizefmt,asize)
       afil1=afil;  asize1=asize ;
       adate1=ndate
       if showdate=1 then adate1=dateconv(ndate,'s','n')
       if showtime=1 & showdate=1 then do
          geeks=copies(' ',14-length(adate1))
          adate1=adate1||geeks||atime
       end
       afiller=' '
       if usepre=1 then do
           girls=length(afil1)
           if do_zipexpand=1 then girls=girls+4
           afiller=copies(' ',20-girls)
           asize1=left(asize1,10)
           adate1=left(adate1,21)
       end  /* Do */
 
       flist.i.afile=afil1
       flist.i.size=asize1
       flist.i.date=adate1

       afil2=adir||"/"||afil ; afil2t=afil2

       dazip=mk_zipexpand(afil,fname,do_zipexpand,list)  /* use true name */
       if dazip<>' ' then nzipfs=nzipfs+1

       ftext=0 ; if forcetext<>0 then ftext=1
       if dorecord=1 then  
           afil2="SENDFILE?"||afil2||'&FORCETEXT='||ftext
       if dorecord=0 & forcetext<>0 then do
            if forcetext=1 then afil2='!SENDAS_TEXT_PLAIN?'||afil2
            if forcetext=2 then afil2='!SENDAS_CHECK_TYPE?'||afil2
            if forcetext=3 then afil2='!SENDAS_CHECK_TEXT?'||afil2
       end
       if filetable=1  & usedl=0 then do   /*force size/date in own column*/
          if showgifs=1 then do
             agif=dazip
             if agif=' ' then   agif=imagetype(fname,theind,theind2,thumbsel)
             flist.i.name='  '  agif ' <a href="' ||afil2||'"'||viewin'>' afil1  '</a> ' afiller
         end
         else
             flist.i.name=dazip||'  <a href="' ||  afil2||'"'||viewin||'>' afil1  '</a>  ' afiller
       end
       else  do            /* put size/date with name */
          jasize=asize1 ; if showsize=0 then jasize=' '
          jadate=adate1 ; if showdate=0 then jadate= ' '
                         if usepre=1 then jadate=left(jadate,21)
                         
          dl1='(' ; dl2=',' ; dl3=')' ;
          if jadate=' ' & jasize=' ' then do ; dl1=' ' ; dl2=' '; dl3=' '; end
          if jasize=' ' then  dl2=' '
          if jadate=' ' then  dl2=' '
          if usepre=1 then do
             dl1=' '; dl2=' ' ; dl3=' '
          end  /* Do */
          pre1=' ' ; pre2=' '
 
          if showgifs=1 then do
             agif=dazip
             if agif=' ' then agif=imagetype(fname,theind,theind2,thumbsel)
             flist.i.name=pre1 '  '  agif ' <a href="'||afil2||'"'||viewin||'>' afil1  '</a>' ,
                       afiller   dl1 jadate dl2 jasize dl3 pre2
          end
          else
             flist.i.name=pre1 ||dazip '  <a href="' || afil2||'"'||viewin||'>' afil1  '</a> ' ,
                          afiller  dl1 jadate dl2 jasize dl3 pre2
       end            /* put size/date */
  end    /* i 1 to flist.0 */

  oldmess2=oldmess

/* replace DIR= with DIROLD= (retained for grins, not actually used by getafile) */
   oldmess2=sref_replacestrg(oldmess2,'&DIR=','&DIROLD=')
   if abbrev(oldmess2,'DIR=')=1 then
      oldmess2=sref_replacestrg(oldmess2,'DIR=','DIROLD=')  /* just do the first one */

/*replace ROOTDIR="!" with ROOTDIR=rootdir (the variable's value) */
   oldmess2=sref_replacestrg(oldmess2,'=!','='||rootdir)

/* get subdirectories ? */

  if dodirs=1 then do
     rc2=sysfiletree(lookin,dirlist,"OD")
     if rc2 <> 0 then do    /* error */
       call error_3
       oof=dosdir(tempfile,'s')
       return 'FILE ERASE TYPE text/html NAME' tempfile
     end
     imm=0
     do mm=1 to dirlist.0
        if dosisdir(dirlist.mm)=0 then iterate  /*tvfs bug fix */
        imm=imm+1
        parse var dirlist.mm (thepath) teco
        dirlist.imm=translate(adir||teco,'/','\')
     end
     dirlist.0=imm      


/*   create list of directories, and add the .. directory if needed */
     LP1=LASTPOS('/',ADIR)
     do mm=dirlist.0 to 1 by -1  /* move 'em down */
           if adir<>"" then
              mm1=mm+1
           else 
              mm1=mm
           dirlist.mm1=dirlist.mm
           dirg=dirlist.mm1
           dirg0=translate(dirg,' ','/\'); dirg0=word(dirg0,words(dirg0))
           if wordpos('/'||upper(dirg0),exclusion_list)>0 then do
                dirlist.mm1.name=' '
                iterate
           end  /* Do */

           dirlist.mm1.aname=dirg
           dirg2=translate(dirg,'/','\')
           dirg2="/GETAFILE?DIR="||dirg2||oldmess2
           if showgifs=1 then
              dirlist.mm1.name='  ' dirgif ' <a href="' ||dirg2|| '"> '|| dirg0 ||   ' </a>'
           else
              dirlist.mm1.name='  <a href="' ||dirg2|| '"> '|| dirg0 ||   ' </a>'

      end
      if adir<>""  then do              /* if not at root */
        dirlist.0=dirlist.0+1
        IF LP1>1 THEN DO ;           /*below first level subdirectory */
           DIRG1=SUBSTR(ADIR,1,LP1-1) ;
           dirlist.1.aname=dirg1
           dirlist.1=dirg1
           if showgifs=1 then
              dirlist.1.name=' ' dirgif ' <A HREF="/GETAFILE?DIR='||DIRG1||oldmess2'"> (.. parent) </A>'
           else
              dirlist.1.name=' <A HREF="/GETAFILE?DIR='||DIRG1||oldmess2'"> (.. parent) </A>'
        END
        ELSE do   /* must be 1st level directory, so display root */
           dirlist.1=""
           if showgifs=1 then 
              dirlist.1.name=' ' backgif ' <A HREF="/GETAFILE?DIR=/'||oldmess2||'"> ..  (parent) </A>'
           else
              dirlist.1.name=' <A HREF="/GETAFILE?DIR=/'||oldmess2||'"> ..  (parent) </A>'
           dirlist.1.aname=""

        end
     END            /* add parent */


/* rootdir condition check */
    rootdir=strip(rootdir); rootdir=translate(rootdir,'/','\')
    rootdir=strip(rootdir,,'/')
    do m=1 to dirlist.0
       if rootdir<>0 then do
          t1=translate(dirlist.m.aname,'/','\')
          t2=strip(dirlist.m.aname,,'/')
          dirlist.ok.m=abbrev(t2,rootdir)
       end
       else
           dirlist.ok.m=1
    end

  end                   /* dodirs */

/* read in the file, if wanted */
readmelines.0=0
if readmefile<>0 then do
   yow=thepath||'\'||readmefile
   nlines=fileread(yow,'filelines')
   readmelines.0=nlines
   if nlines>0 then
     do pp=1 to nlines
       readmelines.pp=filelines.pp
     end
   else do
     readmefile=0  /* signal no success */
     if VERBOSE>0 then say " Could not find display file: " readmefile
   end

end
if tablefile<>0 & filekey=1 then do   /*key matching table */
    dispdata=sref_grab_file(thepath||'\'tablefile,30)
    if dispdata=0 then do
      tablefile=0 ; tablefile_mess=0
      dispdata=""
    end                                      
end
if tablefile<>0 & filekey=2 then do   /*key matching table */
    if tablefile=0 then do then
        lstandard.0=0
        tablefile_mess=0
        dispdata=""
    end  /* Do */
    else do
       afoo=fileread(thepath||'\'tablefile,lstandard,,'E')
       if lstandard.0=0 then do
          tablefile=0 ; tablefile_mess=0
          dispdata="" ; lstandard.0=0
       end
      else do
         foo=fix_lstandard(0)
      end  /* Do */
    end
end

if tablefile=0 then do   /* avoid problems below */
   lstandard.0=0
        tablefile_mess=0
        dispdata=""
end  /* Do */

tablelines.0=0
if tablefile<>0 & filetable=1 & filekey=0 then do  /* line matching table */
   yow=thepath||'\'||tablefile
   nlines=fileread(yow,'filelines')

   tablelines.0=nlines
   if nlines=0 then do
        tablefile=0 ; tablefile_mess=0
   end
   else do
       do pp=1 to nlines
           tablelines.pp=fix_desc(filelines.pp,html_descripts)
        end
   end
end

/* intro to this htm */
if header=1 & iscreate=1 then header='/'strip(foodir2,'l','/')
call lineout tempfile,'<h2> ' header ' </h2>'


if readmefile<>0 & attop=1  then do
    call showdafile readmelines.0,maxlines
end

if iscreate=0 then do
  if dodirs=1 then do
     ndd=dirlist.0
     if strip(foodir2)<>"/"  then ndd=ndd-1
     call lineout tempfile,"  <strong> " FLIST.0 " files,  and " ndd " subdirectories, in " foodir2 " </strong> "
  end
  else do
     call lineout tempfile,"  <strong> " FLIST.0 " files in " foodir2 " </strong> "
  end

  CAll lineout tempfile," <p> Select the file you want to retrieve "
  call lineout tempfile,' <em> You might need to turn on your browser''s "Save to file mode" option </em>'
  if nzipfs>0 then do
    call lineout tempfile,' <blockquote> The  <b>+</b> icon (or the <u>[vu]</u> link) will '
    call lineout tempfile,' <em>expand</em> a .ZIP archive </blockquote>'
  end
end
/*** table stuff complicates things !! */

select
/* no table */
   when dirtable+filetable=0  then do   /* no table */

      if usepre=1  then do
          if showgifs=1 then
            call lineout tempfile,'<br> <pre>    ' ballgif ' <b> <u>   Name                 Last Modified        Size </u> </b> <br> </pre>'
         else
            call lineout tempfile,' <br> <pre> <b>  <u>   Name                   Last Modified        Size </b> </u> <br> </pre> '
       end

     if dodirs=1 & dirtop=1 then do
       
       if iscreate<>1 & usepre<>1 then do
         if adir="" then
            call lineout tempfile, " <hr> <h3> Subdirectories </h3>"
         else
            call lineout tempfile, " <hr> <h3> Subdirectories of /"strip(adir,'t','/') ' </h3>'
       end
       else do
                 call lineout tempfile," <br> "
       end

       call lineout tempfile, " <menu>  "
       if dirlist.0=0 then do
         call lineout tempfile,' <LI> No subdirectories! '
       end
       else do
         do mm=1 to dirlist.0
            if dirlist.ok.mm=1 then
                call lineout tempfile,' <li> ' dirlist.mm.name
         end
       end
       call lineout tempfile,' </menu>  '
     end                        /* dirtop */

    if iscreate=0  & usepre=0 then do
            call lineout tempfile, ' <hr> <h3> Listing of ' foodir2 ' </h3>'
    end
 
    if usepre=1  then do
          call lineout tempfile,' <pre>    ' 
    end
    else do
       call lineout tempfile,' <menu> '
    end
    
    IF FLIST.0=0 THEN do
           CALL LINEOUT TEMPFILE,'  <li> No files in ' adir
    end
    else do
           do jj=1 to flist.0
             if flist.jj.name=' ' then iterate
             if usepre=1  then
               call lineout tempfile, flist.jj.name
             else
               call lineout tempfile, '<li> ' flist.jj.name
           end
    end
    if usepre=1 then
       call lineout tempfile,' </pre> <hr> '
    else
       call lineout tempfile,' </menu> <hr> '

     if dodirs=1 & dirtop=0 then do
       if iscreate<>1 then do
         if adir="" then
            call lineout tempfile, "  <h3> Subdirectories </h3>"
         else
            call lineout tempfile, "  <h3> Subdirectories of /"strip(adir,'l','/') ' </h3>'
       end
       else
           call lineout tempfile,' <br> '

       call lineout tempfile, " <menu>  "
       if dirlist.0=0 then do
         call lineout tempfile,' <LI> No subdirectories! '
       end
       else do
         do mm=1 to dirlist.0
            if dirlist.mm.name=' ' then iterate
            if dirlist.ok.mm=1 then
                call lineout tempfile,' <li> ' dirlist.mm.name
         end
       end
       call lineout tempfile,' </menu>  '
     end                        /* dirbottom */


   end                  /* no table section */

/* table of files and subds */
   when dirtable=1 then do

/* setup a multi column table:: file names first, then subdirectories. */

     call lineout tempfile, "      <table border=0> "
     select
       when showsize=1 & showdate>0 then
         call lineout tempfile, ' <th colspan=' tablecols '> files and subdirectories (date ,size)'
       when if showsize=1 then
         call lineout tempfile, ' <th colspan=' tablecols '> files and subdirectories (size)'
       when showdate>0 then
         call lineout tempfile, ' <th colspan=' tablecols '> files and subdirectories (date)'
       otherwise
        call lineout tempfile, ' <th colspan=' tablecols '> files  and subdirectories '
      end

     goof=''
     nthrow=1
     call out_tr

     ifoo=0
     nthrow=1

     do mm=1 to flist.0
       if flist.mm.name=' ' then iterate
       ifoo=ifoo+1
       call lineout tempfile,'<td valign="top"> ' flist.mm.name '</td> '
       if ifoo>=tablecols then do
            nthrow=nthrow+1
            call out_tr
            ifoo=0
        end
     end
     if dodirs=1 then do
        ifoo=ifoo+1
        call lineout tempfile,'<td valign="top" align="center">  ::::  </td> '
        if ifoo>=tablecols then do
            nthrow=nthrow+1
            call out_tr
            ifoo=0
        end
 
        do mm=1 to dirlist.0
          if dirlist.ok.mm=0 then iterate
          if dirlist.mm.name=' ' then iterate
          ifoo=ifoo+1
          call lineout tempfile,'<td valign="top">  <b> ' dirlist.mm.name ' </b> </td>'
          if ifoo>=tablecols then do
            nthrow=nthrow+1
            call out_tr
          end
        end
     end

     call lineout tempfile,' </table> '

   end
/*table of file&subds, displayed file */
   when filetable=1 then do
     foo1=""
     nthrow=1
     if tablefile<>0 then
         if tablefile_mess<>0 then
                foo1=tablefile_mess
          else
                foo1='Description from:'||tablefile

     if usedl=0 then do
        call lineout tempfile, "      <table border="tableborder" cellspacing="cellspacing "> "
        call lineout tempfile, ' <th ALIGN="center" nowrap > files&nbsp;and&nbsp;subdirectories '
        if showsize=1  then call lineout tempfile,' <th align="center"> <tt> size </tt> '
        if showdate>0 then call lineout tempfile,' <th align="center"> <tt> creation date </tt> '

        if filekey>0 then do
          if tablefile<>0 then
             call lineout tempfile, ' <th  ALIGN="center"> ' foo1
          ELSE
             call lineout tempfile, ' <th ALIGN="left"> '
        end
        else do
          if tablefile<>0 then
             call lineout tempfile, ' <th ALIGN="left"> ' foo1
          else
             call lineout tempfile, ' <th ALIGN="left"> '
        end
        nthrow=nthrow+1
        call out_tr
      end
      else  do             /* set up a dl */
         if foo1<>" " then
            call lineout tempfile,' <p> Files and directories (' foo1 ")"
         else
           call lineout tempfile,' <p> Files and directories '
         call lineout tempfile ,'<p> <dl> '
      end

     IDONE=0
     do igoo=1 to flist.0
        gotit=''
        if flist.igoo.name=' ' then iterate
        if usedl=1 then do
            if filekey=0 then do
               if igoo<=tablelines.0 then
                  gotit=tablelines.igoo
                else
                   gotit=' '
            end
            else do
               if filekey=1 then
                  if html_descripts=0 then 
                      gotit=fix_desc(sref_extract_block(dispdata,strip(flist.igoo.afile),'{','}'),,html_descripts)
               else
                 gotit=find_standard(flist.igoo.afile)
               if gotit="" & auto_describe>0 then 
                    gotit=left(do_auto_describe(thepath'\'flist.igoo.afile,candozip,html_descripts),auto_describe)
            end
            call lineout tempfile,'<dt> ' flist.igoo.name
 
            call lineout tempfile,'<dd> <code> ' gotit '</code>  '
            iterate
         end

/* else, use a table, not a dl list  */

        call lineout tempfile,'<td valign="top"> ' Flist.igoo.name '</td>'
        if showsize=1 then call lineout tempfile,'<td valign="top"> ' Flist.igoo.size '</td>'
        ttdate=flist.igoo.date
        if showdate>0 then call lineout tempfile,'<td valign="top"> ' ttdate '</td>'

        IDONE=IDONE+1

/* display lines as found (one line per cell */
       if filekey=0 then do

          IF IDONE=1 & tableLINES.0=0 THEN
              CALL LINEOUT TEMPFILE,' <TD valign="top"> </td> '
          else
            IF tableLINES.0 >= IGOO THEN
               call lineout tempfile,'<td valign="top"> <code> ' tablelines.igoo '</code> </td> '
          nthrow=nthrow+1
          call out_tr
        end

/* seach file for a key */
        else do                 /* use keyed {xx} search */

            if filekey=1 then
                 gotit=fix_desc(sref_extract_block(dispdata,strip(flist.igoo.afile),'{','}'),html_descripts)
            else
               gotit=find_standard(flist.igoo.afile)
            if gotit=""  & auto_describe>0 then do
                 gotit=do_auto_describe(thepath'\'flist.igoo.afile,candozip,html_descripts)
            end

            if gotit="" then do
                nthrow=nthrow+1
                call out_tr
            end
            else do                      
                call lineout tempfile,' <td valign="top"> ' gotit  ' </td>  '
                nthrow=nthrow+1
                call out_tr
            end
 
        end
     end

     if usedl=0 then do
       CALL LINEOUT TEMPFILE,'  <td> ------ </td> <td> </td>  '
       nthrow=nthrow+1
       call out_tr
     end
     else do
       call lineout tempfile,' <p> '
     end

     if dodirs=1 then do
       igoo2=0
       do igoo=1 to DIRlist.0
        if dirlist.ok.igoo=0 then iterate
        if dirlist.igoo.name=' ' then iterate
        igoo2=igoo2+1

        if usedl=1 then do
            tooth=igoo+flist.0
            if filekey=0 then do
               if tooth<=tablelines.0 then
                   gotit=tablelines.tooth
               else
                    gotit=' '
            end
            else do
              if filekey=1 then
                 gotit=fix_desc(sref_extract_block(dispdata,dirlist.igoo.aname,'{','}'),html_descripts)
              else
                 gotit=find_standard(dirlist.igoo.aname,1)
            end
            if igoo2=1 then
                    call lineout tempfile,'<dt> <hr> <dt>' dirlist.igoo.name
            else
                    call lineout tempfile,'<dt>' dirlist.igoo.name

            call lineout tempfile,'<dd> <code> ' gotit '</code>  '
            iterate
         end

/* else, use a table, not a dl */
         call lineout tempfile,'<td valign="top"> ' DIRlist.igoo.name '</td>'
         idone=idone+1
         if filekey=0 then do
           IF IDONE=1 & tableLINES.0=0 THEN do
               CALL LINEOUT TEMPFILE,' <TD> <EM> No such file (or empty) </em> '
           end
           else do
              tooth=igoo+flist.0
              IF tableLINES.0 >= tooth THEN 
                call lineout tempfile,'<td valign="top"> <code> ' tablelines.tooth '</code> </td> '
           end
           nthrow=nthrow+1
           call out_tr
         end
         else do                /* keyed read.me file */
            if filekey=1 then
                gotit=fix_desc(sref_extract_block(dispdata,dirlist.igoo.aname,'{','}'),html_descripts)
            else
                gotit=find_standard(dirlist.igoo.aname,1)

            if gotit="" then do
                call lineout tempfile,' <td>  </td> '
                nthrow=nthrow+1
                call out_tr
            end
            else do
                call lineout tempfile,' <td valign="top"> ' gotit  ' </td> '
                nthrow=nthrow+1
                call out_tr
            end
         end

       end                      /* dirlist.0 */
      end   /* DO DIRS */


      if usedl=1 then
             call lineout tempfile,' </dl> '
       else
             call lineout tempfile,' </table> '


   END          /* FILETABLE=1 */

   otherwise
end

if readmefile<>0 & attop=0 then do
    call showdafile readmelines.0,maxlines
end

if iscreate=1 then do
  call lineout tempfile,' <p><em> ' servername'/' strip(adir,'l','/') '</em>'
end
call lineout tempfile,' </body> </html> '
call lineout tempfile
ncc=chars(tempfile)
foo=stream(tempfile,'c','close')
oof=dosdir(tempfile,'s')
return 'FILE ERASE TYPE text/html NAME' tempfile


/***********************/
/* write a <tr with bgcolor */
out_tr:
   if tr_colors=1 then do
        itr=nthrow//tr_colors.0
        if itr=0 then itr=tr_colors.0
        goof=tr_colors.itr
   end /* do */
   call lineout tempfile,' <tr ' goof ' > '
   ifoo=0

   return 1



/*******/
/* IMAGETYPE: Return the name of the image file to use based on file type */
/*******/

imagetype: procedure expose ImagePath ImageSize tindex. 
                     

  parse arg isfile,tins,tins2,tinsel
  gifsel=''
  e=extension(arg(1))
  size = ImageSize

/* check for a thumbnail? */
 if tins<>'' then do
   uiu=words(tins)
   do ik=1 to uiu                       /*multiple thumbnails specified */
      thumbindex=strip(word(tins,ik))
      theind2=strip(word(tins2,ik))
      thumbsel=strip(word(tinsel,ik))
      aa0=do_thumbnail(isfile,thumbindex)
      if uiu>1 then tindex.0=0            /* flush "index parameters */
      if aa0<>'' then  do
           parse var aa0 aa1 .
           a2=substr(aa1,theind2+1)
           gifsel=thumbsel||a2
           size="width="tindex.!width" height="tindex.!height
           return '<img src="'gifsel'"' size 'alt="['e']" align="middle">'
      end /* do */
    end          /* words(tins) */
  end      /* thumbindex specified*/

  select
    when e='TXT' | e='CMD' | e='DOC' | e='FAQ' | e='SAS'
      then return '<img src="'ImagePath'text.gif"' size 'alt="[text]">'
    when e='HTM' | e='HTML'
      then return '<img src="'ImagePath'text.gif"' size 'alt="[html]">'
    when e='PS'
      then return '<img src="'ImagePath'text.gif"' size 'alt="[ps]  ">'
    when e='EXE' | e='ZIP' | e='ARC' | e='ARJ'
      then return '<img src="'ImagePath'binary.gif"' size 'alt="[bin] ">'
    when e="AU" | e="WAV" | e="MID"  | e="SND"
      then return '<img src="'ImagePath'sound.gif"' size 'alt="[snd] ">'
    when e="GIF" | e="JPG" | e="JPEG" | e="TIF" | e="TIFF" | e="BMP"
      then return '<img src="'ImagePath'image.gif"' size 'alt="[img] ">'
    when e="MPG" | e="MPEG" | e="AVI"
      then return '<img src="'ImagePath'movie.gif"' size 'alt="[mov] ">'
    otherwise
      return '<img src="'ImagePath'unknown.gif"' size 'alt="[file]">'
  end


extension: procedure
arg filename
/* If no period or only period is first char, then return "" */
if lastpos(".",filename)<2 then return ""
return translate(substr(filename, lastpos('.',filename)+1))


/* ************************************/
/* create a zip-expansion link */
mk_zipexpand:procedure expose showgifs expndgif  zip_file_exts
parse arg afil2,fullname,do_zipexpand,oldmess

if do_zipexpand<>1 then return ' '

goon=isazipfile(fullname,zip_file_exts)
if goon<1 then return ' '

afil2=strip(afil2)
/* is a .zip file-- allow for expansion */
foo='<A HREF="/GETAFILE?doexpandzip='||afil2||'&backto=&'||translate(oldmess,'+',' ')||'">'
if showgifs=1 then
  foo=foo||expndgif||' </a> '
else
  foo=foo||'[vu]</a> '

return foo



/***********************/
IsAZipFile:procedure
/*  This checks if a file is really a .ZIP file instead of relying on
    a .ZIP extension.  Handy for finding Self-Extracting zip files that
    have .EXE extensions so that UNZIP can be used on them also.
    Requires the FILEREXX.DLL although it could be rewritten to use
    the Rexx stream functions instead.  I used FileRexx so the file
    in question could be opened in read share mode which stream can't do.
    Function syntax: Rc = IsFileAZipFile( FileNameToCheck ',' Verbose)
    FileNameToCheck should be a fully qualified file name, Verbose
    can be 0 = no display, 1 = say display, 2 = pmprintf display
    Function returns: -1 = Error opening file, 0 = file is NOT a zip
    file, 1 = file is a standard zip file, 2 = file is self-extracting.
    Originally written on 07/25/97 by Steve Ryckman (sryckman@simsware.com)
    Function can be freely distributed as long as this header remains intact.
(note: this has been modified by Daniel Hellerstein 
       check_for_zip=0, then just check for ZIP extenstion,
                    =1, then do the contents check
*/

parse arg AbsolutePath , zipexts
AbsolutePath = strip( AbsolutePath)

a1=lastpos('.',absolutepath);anext=''
if a1>0 then anext=upper(substr(absolutepath,a1+1))

ug1:   nop              /* jump here if can't file filerexx procs */
/* standard mode: do NOT check */
if zipexts=' ' | zipexts=0 | a1=0 then do
    if anext='ZIP' then return 1
    return 0
end  /* Do */

if wordpos(anext,upper(zipexts))=0  then return 0

/* else, check file contents to see if it's a zip file */

/* first,load filerexx functions */
if rxfuncquery('fileread_rxf')=1 then do
   goti1=RxFuncAdd('Fileread_rxf', 'FILEREXX', 'fileread')
end
if rxfuncquery('fileread_rxf')=1 then do
   zipexts=0
   signal ug1
end

/* filerexx found, load some functions */

if rxfuncquery('fileopen_rxf')=1 then do
     goti2=RxFuncAdd('FILEOPEN_RXF', 'FILEREXX', 'fileopen')
end
if rxfuncquery('fileclose_rxf')=1 then do
   goti3=RxFuncAdd('Fileclose_rxf', 'FILEREXX', 'fileclose')
end
if rxfuncquery('fileseek_rxf')=1 then do
   goti3=RxFuncAdd('FileSeek_rxf', 'FILEREXX', 'fileseek')
end

absolutepath=stream(absolutepath,'c','query exists')
                                                              
filehandle = fileopen_rxf(AbsolutePath, 'a+rs', 'e', 0)
if filehandle = '0' then return(-1)  /* can't open, assume not .zip file */

ZipFile = 0
/* Check the position past the .EXE header first */
slotoffset = x2d('3BF5')
result = FileSeek_rxf(filehandle, slotoffset, 0)
DataRecord = FileRead_rxf(filehandle, 2)
if left(DataRecord,2)='PK' then ZipFile = 2

/* Now check the very first two bytes in the file */
slotoffset = 0
result = FileSeek_rxf(filehandle, slotoffset, 0)
DataRecord = FileRead_rxf(filehandle, 2)
if left(DataRecord,2)='PK' then ZipFile = 1

rc = FileClose_rxf( filehandle)
return(zipfile)


/************/
/* display the readmefile */
showdafile:             /* display the file */

  parse arg mlines,maxlines
  call lineout tempfile,' <hr> '
  if readmefile_mess=0 | readmefile_mess="" then readmefile_mess=' Displaying: ' ||readmefile
  if mlines = 0 then 
    nop
  else do
     call lineout tempfile,' <h3> ' readmefile_mess ' </h3> <pre> '
     do mm=1 to min(mlines,maxlines)
         call lineout tempfile,readmelines.mm
     end
     call lineout tempfile, ' </pre> '
     if notdone=1 then
        call lineout tempfile,' <br> <em> Only first ' mlines ' lines are displayed </em> '
  end
  call lineout tempfile,' <hr> '
  return 0



error_1:
     call lineout tempfile, "<h3>Could not get a file</h3"
     call lineout tempfile, " <p> (probably a memory problem) "
     call lineout tempfile, "<hr></body></html>"
     call lineout tempfile                          /* close */
     if VERBOSE>0 then say " (GETAFILE) Memory problem ? "
     foo=directory(olddir)
     return 1

error_0:
     if iscreate=0 then do
        call lineout tempfile, "<h3>Could not get a file </h3>"
        call lineout tempfile, " <p> The file directory does not exist: " adir
     end
     else
        call lineout tempfile,' <br> Unavailable '
     call lineout tempfile, "<hr></body></html>"
     call lineout tempfile                          /* close */
     if VERBOSE>0 then say " DIR " adir " does not exist"
     return 1
 
error_3:
       call lineout tempfile, "<h3>Could not get a subdirectory</h3>"
       call lineout tempfile, " <p> (probably a memory problem) "
       call lineout tempfile, "<hr></body></html>"
       call lineout tempfile                          /* close */
       if VERBOSE>0 then say " (GETAFILE) Memory problem ? "
       return

error_4:
  call lineout tempfile,' <!DOCTYPE HTML PUBLIC  "-//Netscape Comm. Corp.//DTD HTML//EN">'
  call lineout tempfile, "<html><head><title> Error in ZIP expansion </title></head>"
  call lineout tempfile, "<body>"
  call lineout tempfile, "<h3>UNZIP Not available</h3>"
  call lineout tempfile, " <p> server is improperly configured "
  call lineout tempfile, "<hr></body></html>"
  call lineout tempfile                          /* close */
  if VERBOSE>0 then say " (GETAFILE) no unzipapi "
  return



/* ----------- */                                                        
/* get environment value, possibly host specific */                      
/* ------------ */                                                       
get_value: procedure expose enmadd host_nickname                          
parse arg vname,hname0
if hname0=0 then 
        hname=' '
else                                                    
    hname=strip(host_nickname)                          

vname=strip(vname) ;
if hname<>' ' then do
   booger=strip(enmadd||vname||'.'||hname)
   aval=value(booger,,'os2environment')
   if aval<>' ' Then                                                     
        return aval                                                      
end                                                                      
aval=value(enmadd||vname,,'os2environment')                              
return aval   


/* fix up size, given format */
fixup_size:procedure
parse arg sizefmt,asize
 if translate(sizefmt)="ABBREV" then do
               if asize>=1000000 then
                       return format(asize/1000000,,0)||'M'
               if asize>=1000 then 
                      return format(asize/1000,,0)||'K'
 end
/* convert to xxx,yyy,zzz */
 il=length(asize)
 if il>3 then do
           oop=""
           do mm=il to 3 by -3
               tt=substr(asize,mm-2,3)
               if mm=il then
                  oop=tt
               else
                 oop=tt||','||oop
           end /* do */
           if mm<>0 then oop=substr(asize,1,mm)||','||oop
           asize=oop
 end
 return asize    /* not abbrev, or < 1000 */


/* search lstandard for a match to filename or dirname */
find_standard:procedure expose lstandard.
parse upper arg afile,issub

afile=strip(afile)

if issub=1 then do
   oo=translate(afile,' ','/\')
   afile='/'||word(oo,words(oo))
end  /* Do */

if lstandard.0=0 then return ' '
do ll=1 to lstandard.0
   aword=lstandard.ll.name
   if aword=afile then   return lstandard.ll
end /* do */
return ' '



/******** fix up standard description file */
fix_lstandard:procedure expose lstandard. html_descripts

if lstandard.0<2 then return 0

ndo=0
do ll=1 to lstandard.0
  aline=strip(lstandard.ll)
  if aline="" | abbrev(aline,';')=1 then iterate
  ndo=ndo+1
  tmp.ndo=aline
end
if ndo=0 then do
   lstandard.0=0
   return 0
end  /* Do */

tmp.0=ndo
foo=arraysort(tmp,,,,,'A','I')

drop lstandard.
do ll=1 to ndo
   lstandard.ll.name=translate(upper(strip(word(tmp.ll,1))),'/','\')
   lstandard.ll=fix_desc(subword(tmp.ll,2),html_descripts)
end
lstandard.0=ndo
return ndo


/****************/
do_auto_describe:procedure
parse arg athing,ado,ifix
ALINE0=sref_auto_describe(ATHING,ADO)
aline0=fix_desc(aline0,ifix)
RETURN ALINE0


/************/
fix_desc:procedure
parse arg aline0, fixit
if fixit=1 then return aline0

aline0=sref_replacestrg(aline0,'&','&amp;','ALL')
aline0=sref_replacestrg(aline0,'<','&lt;','ALL')
aline0=sref_replacestrg(aline0,'>','&gt;','ALL')
aline0=sref_replacestrg(aline0,'"','&quot;','ALL')
return aline0



/*********************************/
/* expand a .zip file (adapted from the BBS add-on */

show_zipdir:procedure expose  tempfile ballgif backgif thumbindex imagepath imagesize ,
                              viewin forcetext showgifs
parse arg  zipfile,adir,backto,lookin

foo=lastpos('\',lookin)
lookin=delstr(lookin,foo+1)
mkit=lookin||zipfile

rc=uzfiletree(mkit,getem,,,'Z')
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
call lineout tempfile, "<HTML>"
call lineout tempfile, "<HEAD>"
call lineout tempfile, "<TITLE>Contents of "zipfile"</TITLE>"
oo=strip(adir,'t','/')'/'zipfile
call lineout tempfile, "</HEAD> <body> <h2> Contents of " oo '</h2>'


call lineout tempfile, '<pre>' ballgif '<b>'left("Name",19)||left("Last Modified",17)||right("Size",8)'</b></pre>'
call lineout tempfile, '<hr>'
fbackto=translate(backto,'+',' ')
call lineout tempfile, '<dt><pre><a href="/GETAFILE?'fbackto'">'||backgif||'Back</a></pre>'
call lineout tempfile, '<HR>'


do mm=1 to getem.0
    aline=getem.mm
    Fname=word(aline,8)
    Ftime=word(aline,6)
    Fdate=word(aline,5)
    parse var  fdate mmm '-' ddd '-' yyy
    if yyy<70 then
        yyy='20'||yyy
    else
        yyy='19'||yyy
    qdate=yyy||mmm||ddd
    fdate=dateconv(qdate,'S','N')

    Fsize=word(aline,1)
    feeb=' '
    if showgifs=1 then    feeb=imagetype(fname)
    feeb1='/GETAFILE?FILE_FROMZIP='fname'&DIR='adir'&zipfile='zipfile
    if forcetext=1 then feeb1=feeb1||'&forcetext=1'
    if showgifs=1 then feeb1=feeb1||'&showgifs=1'
    feeb3=feeb||'<A href="'||feeb1||'"'||viewin||'> '||fname||'</a>'
    call lineout tempfile, '<dt><pre>'feeb3''copies(' ',max(0,20-length(Fname)))''right(Fdate,10)''right(Ftime,6)' 'right(Fsize,10)'</pre></dt>'
end

call lineout tempfile, "</dl>"
call lineout tempfile, "</BODY>"
call lineout tempfile, "</HTML>"
call lineout tempfile

aa=stream(tempfile,'c','close')

return 0




/**************/
/* Extract and send a zip file.
zipfile: The "local" file to be unzipped
zipdir:  url-directory of the zipfile
*/
send_zipfile:procedure expose tempfile forcetext showgifs
parse arg  getfile,zipfile,lookin

foo=lastpos('\',lookin)
lookin=delstr(lookin,foo+1)
mkit=lookin||zipfile
/* make sure it exists */
if stream(mkit,'c','query exists')=' ' then  do
  call lineout tempfile, "<body><h2>Sorry...</h2>"
  call lineout tempfile,' Could not find .ZIP file: ' zipfile
  call lineout tempfile, "</body></html>"
  call lineout tempfile  /* close */
   oof=dosdir(tempfile,'s')
  return 'FILE ERASE TYPE text/html NAME ' tempfile
end
rc=uzunziptostem(mkit,'sook.',getfile)
if sook.0=1 then do
  arf=strip(sook.1)
  thesize=length(sook.arf)
  if thesize=0 then do  /* hack to get around unzip.dll ?bug? */
     sook.arf=uzunziptovar(mkit,getfile)
     thesize=length(sook.arf)
  end
  if forcetext<>0 then
     atype='text/plain'
  else
     atype=sref_mediatype(getfile)
   oo=value('sref_prefix',,'os2environment')
   if oo='' then do
     'VAR TYPE ' atype ' as ' getfile ' name sook.arf '
   end
   else do
     foog=sook.arf      /* sometime problems passing stem vars */
     foo=sref_gos('VAR TYPE ' atype ' as ' getfile ' name foog',foog)
   end
  return '200 '||length(sook.arf)
end
else do
  call lineout tempfile, "<body><h2>Sorry...</h2>"
  call lineout tempfile,' Could not find Zipped file: ' getfile
  call lineout tempfile, "</body></html>"
  call lineout tempfile  /* close */
   oof=dosdir(tempfile,'s')
  return 'FILE ERASE TYPE text/html NAME ' tempfile
end


/************************/
/* check access rights for this request  */
check_access:procedure
 parse  upper arg adir, lookin, zipfile, host_nickname, enmadd, transaction, apri

if adir<>' ' then
   args='/'||strip(translate(adir,'/','\'),,'/')||'/'||zipfile
else
   args='/'||zipfile

goober=enmadd||'ACCESS'
dothread='\SEM32\'||enmadd||'ACCESS'

atid=dostid()
myqueue=enmadd||'t'||atid
mysem='\SEM32\'||enmadd||'t'||atid

if get_value('SUPPRESS_ACCESS',0)=1 then  do  /* no access file */
    return 1
end

again1t:

  a=rxqueue('s',goober)

  queue  transaction ' ' host_nickname ',' myqueue ',' mysem ','  ARGS
/*   push  transaction ',' myqueue ',' mysem ','ARGS */

  a=eventsem_reset(mysem)
  a=eventsem_post(dothread)
again2t:
  a=eventsem_wait(mysem,90000)

  if a<>0 then do
        call pmprintf(mytid','athread' A Fatal Semaphore failure: 'a)
        String 'Web server is temporarily busy '
        exit ' '
  end
  a=rxqueue('s',myqueue)

  parse pull aline
  PARSE VAR ALINE idnum ',' aline
  idnum=strip(translate(idnum,' ','000d0a'x));TRANSACTION=STRIP(TRANSACTION)
  if idnum<>transaction then  do /*wierd error: got someone else's message! */
      say ' Read odd id from queue 'athread ':' transaction ',' idnum
      if eventsem_query(mysem)=1 then aa=eventsem_reset(mysem)
      String 'Web server is temporarily busy '
      exit ' '
  end

  parse upper var aline . ',' respriv
/* check privs */
  do mm=1 to words('* '||apri)
      if wordpos(word('* '||apri,mm),respriv)=1 then return 1
  end
  return 0

  return aline

/***************************/
/* wild card comparison against a list */
wild_wordpos:procedure
parse arg needle,haystack
needle=strip(needle)
foo=wordpos(needle,haystack)
if foo>0 then return foo

if pos('*',haystack)=0 then return 0

do mm=1 to words(haystack)
  aw=strip(word(haystack,mm))
  if pos('*',aw)=0 then iterate
  foo=sref_wildcard(needle,aw)
  parse var foo a1 ',' . ; a1=strip(a1)
  if a1>0 then return mm
end
return 0



/*************************************/
/* return the 'cached image'. 0=error, 1=http 200, 2=http 302 */
do_thumbnail:procedure expose verbose tindex.
parse arg thefile,theind

if stream(theind,'c','query exists')='' then do
   if verbose>3  then say "GETAFILE Error: No thumbnail index=" theind
   return ''  /* no such index */
end


if tindex.0<>1 then do
  afoo=linein(theind) 
  parse  var afoo tindex.!reclen tindex.!numrec tindex.!idlen tindex.!cshlen tindex.!dasel ,
         tindex.!width tindex.!height .
  tindex.0=1
end
foo=stream(theind,'c','close')
aa=search_fixed(thefile,theind,tindex.!numrec,tindex.!reclen+2,1,1,tindex.!idlen,0)
if aa="" then return ''         /* no entry for this file */

aa=translate(aa,' ','0d0a'x)
parse var aa filename cachename cachedate .
yerf=date_match(filename,cachedate)
if yerf<>0 then return ''               /* out of date */
cachename=stream(cachename,'c','query exists')
if cachename='' then return ''          /* no such thumbnail */

return cachename

/***************/
/*Search a sorted, fixed record file for a match 
*/

search_fixed:procedure

parse arg target,thefile,numrec,reclen,recoffset,idat,idlen

oo=sref_open_read(thefile,30)
if oo<0 then return ''    /* could not open, could not read */

  ib=1
  ie=numrec
  iat=((recoffset+ib-1)*reclen)+idat
  indxib=charin(thefile,iat,idlen)

  indxib=strip(translate(indxib))

  iat=((recoffset+ie-1)*reclen)+idat
  indxie=charin(thefile,iat,idlen)
  indxie=strip(translate(indxie))
  
  target=strip(translate(target))
  
  if target << indxib then do
      foo=stream(thefile,'c','close')
      return ''
   end
  if target>>indxie then do
      foo=stream(thefile,'c','close')
      return ''
  end

/* do the binary search */
 do forever
   len=ie-ib+1
   if (len<=2) then do
     if indxie==target then  do
         iee=((recoffset+ie-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
     end
     if indxib==target then do
         iee=((recoffset+ib-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
     end
     foo=stream(thefile,'c','close')
     return ''  /* did not match */
   end

   imid=trunc(ib+(len/2))
   iat=((recoffset+imid-1)*reclen)+idat
   indximid=charin(thefile,iat,idlen)
   indximid=strip(translate(indximid))
   if indximid==target then do
         iee=((recoffset+imid-1)*reclen)+1
         fgoo=charin(thefile,iee,reclen)
         foo=stream(thefile,'c','close')
         return fgoo
   end

   if (indximid<<target) then do
       indxib=indximid
       ib=imid
   end
   else do
       ie=imid
       indxie=indximid
   end
 end            /* forever */



/***********/
/* check filestamp of dafile against dastamp 
return
0=ok
1=no such dafile
2=mismatch in timestamp */
date_match:procedure
parse arg dafile,dastamp
dastamp=strip(dastamp)
  aa=sysfiletree(dafile,yowk,'TF')
  if yowk.0=0 then return '1'
  parse var yowk.1 datestamp .  ; datestamp=strip(datestamp)
  if dastamp<>datestamp then return '2'
  return 0



